Debian Bug report logs - #580946
interoperability problem with scroll lock toggles on xkb

version graph

Package: xterm; Maintainer for xterm is Debian X Strike Force <debian-x@lists.debian.org>; Source for xterm is src:xterm.

Reported by: antoine beaupre <anarcat@anarcat.ath.cx>

Date: Mon, 10 May 2010 03:39:01 UTC

Severity: important

Tags: moreinfo

Found in version xterm/258-1

Fixed in versions xterm/256-1, xterm/259-1

Done: Julien Cristau <jcristau@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#580946; Package xterm. (Mon, 10 May 2010 03:39:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to antoine beaupre <anarcat@anarcat.ath.cx>:
New Bug report received and forwarded. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Mon, 10 May 2010 03:39:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: antoine beaupre <anarcat@anarcat.ath.cx>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: xterm: latest upgrade broke scrolling on kFreeBSD
Date: Sun, 09 May 2010 19:34:31 -0400
Package: xterm
Version: 258-1
Severity: important
User: debian-bsd@lists.debian.org
Usertags: kfreebsd

This problem is fairly weird and hard to describe so bear with me.

It only affects xterm. I'm reporting this in rxvt, which doesn't suffer
from that problem.

The problem is this: the display doesn't scroll once you get to the
bottom of the screen. So for example, if you cat(1) a file that has more
lines that what you have in your terminal, you'll only see the top of
the file even though cat(1) showed the whole file.

This gives... interesting results in ncurses based programs like irssi
or screen (hint: it's just messed up).

I recently did the following upgrades:

kfreebsd-image-7-486 7.2-11 -> 7.3-1
xorg 1:7.5+5 -> 1:7.5+6
xterm 256-1 -> 258-1

(amongst ~420 others). So this is certainly a regression with one of
those. When I install xterm-256, the bug goes away, so I decided to
report this against xterm.

-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: kfreebsd-i386 (i686)

Kernel: kFreeBSD 7.3-1-686
Locale: LANG=fr_CA.UTF-8, LC_CTYPE=fr_CA.UTF-8 (charmap=UTF-8) (ignored: LC_ALL set to fr_CA.UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages xterm depends on:
ii  libc0.1                   2.10.2-7       Embedded GNU C Library: Shared lib
ii  libfontconfig1            2.8.0-2.1      generic font configuration library
ii  libice6                   2:1.0.6-1      X11 Inter-Client Exchange library
ii  libncurses5               5.7+20100313-2 shared libraries for terminal hand
ii  libutempter0              1.1.5-3        A privileged helper for utmp/wtmp 
ii  libx11-6                  2:1.3.3-3      X11 client-side library
ii  libxaw7                   2:1.0.7-1      X11 Athena Widget library
ii  libxft2                   2.1.14-2       FreeType-based font drawing librar
ii  libxmu6                   2:1.0.5-1      X11 miscellaneous utility library
ii  libxt6                    1:1.0.7-1      X11 toolkit intrinsics library
ii  xbitmaps                  1.1.0-1        Base X bitmaps

Versions of packages xterm recommends:
ii  x11-utils                     7.5+3      X11 utilities

Versions of packages xterm suggests:
pn  xfonts-cyrillic               <none>     (no description available)

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#580946; Package xterm. (Tue, 11 May 2010 01:09:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to dickey@his.com:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Tue, 11 May 2010 01:09:07 GMT) Full text and rfc822 format available.

Message #10 received at 580946@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: 580946@bugs.debian.org
Cc: 580946-submitter@bugs.debian.org
Subject: re: #580946 xterm: latest upgrade broke scrolling on kFreeBSD
Date: Mon, 10 May 2010 21:04:47 -0400
[Message part 1 (text/plain, inline)]
I'm not seeing the problem, here.  Just to check, if you have the scroll-lock
key set, it _will_ behave like that (but the LED should be lit for that case).

If it's not scroll-lock, then it's something that I have to see how to repeat.

-- 
Thomas E. Dickey <dickey@invisible-island.net>
http://invisible-island.net
ftp://invisible-island.net
[signature.asc (application/pgp-signature, inline)]

Message sent on to antoine beaupre <anarcat@anarcat.ath.cx>:
Bug#580946. (Tue, 11 May 2010 01:09:11 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#580946; Package xterm. (Tue, 11 May 2010 21:36:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to dickey@his.com:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Tue, 11 May 2010 21:36:06 GMT) Full text and rfc822 format available.

Message #18 received at 580946@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: 580946@bugs.debian.org
Cc: 580946-submitter@bugs.debian.org
Subject: re: #580946 xterm: latest upgrade broke scrolling on kFreeBSD
Date: Tue, 11 May 2010 17:34:41 -0400
[Message part 1 (text/plain, inline)]
If the problem is (for example) a conflict with the user's xmodmap use of
the ScrollLock key, this resource setting is what's needed to work around:

       allowScrollLock (class AllowScrollLock)
               Specifies  whether  control sequences that set/query the Scroll
               Lock key should be allowed, as well as whether the Scroll  Lock
               key responds to user's keypress.  The default is “true.”

-- 
Thomas E. Dickey <dickey@invisible-island.net>
http://invisible-island.net
ftp://invisible-island.net
[signature.asc (application/pgp-signature, inline)]

Message sent on to antoine beaupre <anarcat@anarcat.ath.cx>:
Bug#580946. (Tue, 11 May 2010 21:36:08 GMT) Full text and rfc822 format available.

Added tag(s) moreinfo. Request was from Thomas Dickey <dickey@his.com> to control@bugs.debian.org. (Tue, 11 May 2010 21:39:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#580946; Package xterm. (Wed, 12 May 2010 09:39:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Kan-Ru Chen <koster@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Wed, 12 May 2010 09:39:06 GMT) Full text and rfc822 format available.

Message #28 received at 580946@bugs.debian.org (full text, mbox):

From: Kan-Ru Chen <koster@debian.org>
To: 580946@bugs.debian.org
Cc: 580946-submitter@bugs.debian.org
Subject: Re: Bug#580946: #580946 xterm: latest upgrade broke scrolling on kFreeBSD
Date: Wed, 12 May 2010 17:10:46 +0800
[Message part 1 (text/plain, inline)]
On Tue, 11 May 2010 17:34:41 -0400, Thomas Dickey <dickey@his.com> wrote:
> If the problem is (for example) a conflict with the user's xmodmap use of
> the ScrollLock key, this resource setting is what's needed to work around:
> 
>        allowScrollLock (class AllowScrollLock)
>                Specifies  whether  control sequences that set/query the Scroll
>                Lock key should be allowed, as well as whether the Scroll  Lock
>                key responds to user's keypress.  The default is “true.”
> 

It seems it's related to the fastScroll handling.

In xterm-256 if fastScroll is set, xterm skips large chunks of outputs
like cat /usr/share/dict/words or dmesg

But in xterm-258 the screen flickers and has lots of artifacts.

Maybe in some case the screen will be totally locked? If this is not
that case then I will open a separate bug.

Cheers,
Kanru
[Message part 2 (application/pgp-signature, inline)]

Message sent on to antoine beaupre <anarcat@anarcat.ath.cx>:
Bug#580946. (Wed, 12 May 2010 09:39:10 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#580946; Package xterm. (Thu, 13 May 2010 03:51:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to antoine beaupre <anarcat@anarcat.ath.cx>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Thu, 13 May 2010 03:51:07 GMT) Full text and rfc822 format available.

Message #36 received at 580946@bugs.debian.org (full text, mbox):

From: antoine beaupre <anarcat@anarcat.ath.cx>
To: Debian Bug Tracking System <580946@bugs.debian.org>
Subject: xterm: how to reproduce?
Date: Wed, 12 May 2010 19:37:43 -0400
Package: xterm
Severity: normal

> It only affects xterm. I'm reporting this in rxvt, which doesn't suffer
> from that problem.

I don't know how I could have possibly written that. I'm *not* reporting
this in rxvt. But it's true that rxvt doesn't suffer from this problem,
it's xterm specific.

The problem *is* related with the scroll lock key, thanks for pointing
out that element of the manual. However, the problem is that the scroll
lock key setting persists after xterm is started. Only the initial value
counts.

So for example, if I start xterm with scroll lock pressed, the bug
happens, and even if i "depress" the key, the bug stays there. If I
start xterm with the key depressed, the bug doesn't happen.

I must mention I use a peculiar X configuration that allows me to switch
keyboards with the scroll lock key. I strongly suspect the problem lies
there... I have this in my .xsession:

setxkbmap -layout ca,us -option -option 'grp:sclk_toggle,grp_led:scroll'

If I run this command:

setxkbmap -layout us

the bug goes away, although scroll lock just doesn't work at all
anymore.

I also suspect the problem doesn't lie only within kfreebsd systems, but
I'll do more testing before removing that tag.

So in short, to reproduce the bug:

 1. set the keymap to switch on scroll lock, for example:
    setxkbmap -layout ca,us -option -option 'grp:sclk_toggle,grp_led:scroll'
 2. hit the scroll lock key so it is lit
 3. start xterm
 4. cat a file longer than the number of lines in the xterm

Expected result:

 * the last N lines of the file are shown (where N is the heigth of the
   terminal)

Actual result:

 * only the first N lines of the file are displayed

I hope this is clearer. :)

-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: kfreebsd-i386 (i686)

Kernel: kFreeBSD 7.3-1-686
Locale: LANG=fr_CA.UTF-8, LC_CTYPE=fr_CA.UTF-8 (charmap=UTF-8) (ignored: LC_ALL set to fr_CA.UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages xterm depends on:
ii  libc0.1                   2.10.2-7       Embedded GNU C Library: Shared lib
ii  libfontconfig1            2.8.0-2.1      generic font configuration library
ii  libice6                   2:1.0.6-1      X11 Inter-Client Exchange library
ii  libncurses5               5.7+20100313-2 shared libraries for terminal hand
ii  libutempter0              1.1.5-3        A privileged helper for utmp/wtmp 
ii  libx11-6                  2:1.3.3-3      X11 client-side library
ii  libxaw7                   2:1.0.7-1      X11 Athena Widget library
ii  libxft2                   2.1.14-2       FreeType-based font drawing librar
ii  libxmu6                   2:1.0.5-1      X11 miscellaneous utility library
ii  libxt6                    1:1.0.7-1      X11 toolkit intrinsics library
ii  xbitmaps                  1.1.0-1        Base X bitmaps

Versions of packages xterm recommends:
ii  x11-utils                     7.5+3      X11 utilities

Versions of packages xterm suggests:
pn  xfonts-cyrillic               <none>     (no description available)

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#580946; Package xterm. (Thu, 13 May 2010 04:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to The Anarcat <anarcat@anarcat.ath.cx>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Thu, 13 May 2010 04:27:03 GMT) Full text and rfc822 format available.

Message #41 received at 580946@bugs.debian.org (full text, mbox):

From: The Anarcat <anarcat@anarcat.ath.cx>
To: Debian Bug Tracking System <580946@bugs.debian.org>
Subject: xterm: not only kFreeBSD
Date: Thu, 13 May 2010 00:25:01 -0400
Package: xterm
Version: 258-1
Severity: normal

So this bug also appears on my regular i386 workstation.

I have attempted to remove the usertags, change the title of the bug and
mark it as "fixed in 256" to make it clear it's a regression, i hope i
talked the proper control@bts jargon. :)

-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: i386 (i686)

Kernel: Linux 2.6.32-trunk-686 (SMP w/1 CPU core)
Locale: LANG=fr_CA.UTF-8, LC_CTYPE=fr_CA.UTF-8 (charmap=UTF-8) (ignored: LC_ALL set to fr_CA.UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages xterm depends on:
ii  libc6                     2.10.2-6       Embedded GNU C Library: Shared lib
ii  libfontconfig1            2.8.0-2.1      generic font configuration library
ii  libice6                   2:1.0.6-1      X11 Inter-Client Exchange library
ii  libncurses5               5.7+20100313-2 shared libraries for terminal hand
ii  libutempter0              1.1.5-3        A privileged helper for utmp/wtmp 
ii  libx11-6                  2:1.3.3-3      X11 client-side library
ii  libxaw7                   2:1.0.7-1      X11 Athena Widget library
ii  libxft2                   2.1.14-2       FreeType-based font drawing librar
ii  libxmu6                   2:1.0.5-1      X11 miscellaneous utility library
ii  libxt6                    1:1.0.7-1      X11 toolkit intrinsics library
ii  xbitmaps                  1.1.0-1        Base X bitmaps

Versions of packages xterm recommends:
ii  x11-utils                     7.5+3      X11 utilities
ii  xutils                        1:7.5+6    X Window System utility programs m

Versions of packages xterm suggests:
pn  xfonts-cyrillic               <none>     (no description available)

-- no debconf information




Changed Bug title to 'interoperability problem with scroll lock toggles on xkb' from 'xterm: latest upgrade broke scrolling on kFreeBSD' Request was from The Anarcat <anarcat@koumbit.org> to control@bugs.debian.org. (Thu, 13 May 2010 04:30:03 GMT) Full text and rfc822 format available.

Removed tag(s) moreinfo. Request was from The Anarcat <anarcat@koumbit.org> to control@bugs.debian.org. (Thu, 13 May 2010 04:30:03 GMT) Full text and rfc822 format available.

Bug Marked as fixed in versions xterm/256-1. Request was from The Anarcat <anarcat@koumbit.org> to control@bugs.debian.org. (Thu, 13 May 2010 04:30:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#580946; Package xterm. (Thu, 13 May 2010 19:42:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stanislav Maslovski <stanislav.maslovski@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Thu, 13 May 2010 19:42:05 GMT) Full text and rfc822 format available.

Message #52 received at 580946@bugs.debian.org (full text, mbox):

From: Stanislav Maslovski <stanislav.maslovski@gmail.com>
To: Debian Bug Tracking System <580946@bugs.debian.org>
Subject: latest upgrade broke scrolling on Linux i386 too
Date: Thu, 13 May 2010 23:41:52 +0400
Package: xterm
Severity: normal

I confirm that I see this strange behaviour with scrolling when I run
aptitude update. It produces a long output which quickly fills up all
the window and ... the text does not autoscroll. I can, however,
scroll it manually.

I do not have any specific scroll lock settings, just those that are
provided by default. I can see these lines in my xorg log:

(II) XINPUT: Adding extended input device "Broadcom Corp" (type: KEYBOARD)
(**) Option "xkb_rules" "evdev"
(**) Option "xkb_model" "pc105"
(**) Option "xkb_layout" "us,ru"
(**) Option "xkb_variant" ","
(**) Option "xkb_options" "grp:caps_toggle,terminate:ctrl_alt_bksp,grp_led:scroll"

I am on a standard i386 setup (with sid).

-- System Information:
Debian Release: squeeze/sid
  APT prefers proposed-updates
  APT policy: (500, 'proposed-updates'), (500, 'oldstable'), (500, 'unstable'), (500, 'testing'), (500, 'stable'), (100, 'experimental')
Architecture: i386 (i686)

Kernel: Linux 2.6.32-5-minimal (SMP w/2 CPU cores; PREEMPT)
Locale: LANG=ru_RU.UTF-8, LC_CTYPE=ru_RU.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages xterm depends on:
ii  libc6                     2.10.2-8       Embedded GNU C Library: Shared lib
ii  libfontconfig1            2.8.0-2.1      generic font configuration library
ii  libice6                   2:1.0.6-1      X11 Inter-Client Exchange library
ii  libncurses5               5.7+20100313-2 shared libraries for terminal hand
ii  libutempter0              1.1.5-3        A privileged helper for utmp/wtmp 
ii  libx11-6                  2:1.3.3-3      X11 client-side library
ii  libxaw7                   2:1.0.7-1      X11 Athena Widget library
ii  libxft2                   2.1.14-2       FreeType-based font drawing librar
ii  libxmu6                   2:1.0.5-1      X11 miscellaneous utility library
ii  libxt6                    1:1.0.7-1      X11 toolkit intrinsics library
ii  xbitmaps                  1.1.0-1        Base X bitmaps

Versions of packages xterm recommends:
ii  x11-utils                     7.5+3      X11 utilities
ii  xutils                        1:7.5+6    X Window System utility programs m

Versions of packages xterm suggests:
pn  xfonts-cyrillic               <none>     (no description available)

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#580946; Package xterm. (Thu, 13 May 2010 23:48:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to dickey@his.com:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Thu, 13 May 2010 23:48:03 GMT) Full text and rfc822 format available.

Message #57 received at 580946@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: 580946@bugs.debian.org
Cc: 580946-submitter@bugs.debian.org
Subject: re: #580946 interoperability problem with scroll lock toggles on xkb
Date: Thu, 13 May 2010 19:44:57 -0400
[Message part 1 (text/plain, inline)]
(by the way, patch #258 simply plugs a hole which seems that it should
have appeared in #256 or before, the changes in this bug report come from #257)

This report sounds like two bugs:

a) patch #257 introduces a binding for Scroll_Lock.  While I did make the feature
   configurable (a compile-time ifdef could remove it entirely, or a resource can
   disable most of the feature), I overlooked the fact that other people would be
   using this orphaned key as well.

   For a quick workaround - if you set allowScrollOps resource to false, is the
   intercept of the key still interfering with your use of it?

   (if it is still interfering, I'll have to make the feature configurability
   different, e.g., by deciding whether to add it to the translations dynamically).

b) the scroll-lock feature doesn't work with fast-scrolling.

   Fixing this may take more time than (a), so I'm inclined to focus on being able
   to enable/disable the feature with low impact.

-- 
Thomas E. Dickey <dickey@invisible-island.net>
http://invisible-island.net
ftp://invisible-island.net
[signature.asc (application/pgp-signature, inline)]

Message sent on to antoine beaupre <anarcat@anarcat.ath.cx>:
Bug#580946. (Thu, 13 May 2010 23:48:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#580946; Package xterm. (Fri, 14 May 2010 00:12:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to dickey@his.com:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Fri, 14 May 2010 00:12:03 GMT) Full text and rfc822 format available.

Message #65 received at 580946@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: 580946@bugs.debian.org
Cc: 580946-submitter@bugs.debian.org
Subject: re: #580946 interoperability problem with scroll lock toggles on xkb
Date: Thu, 13 May 2010 20:07:02 -0400
[Message part 1 (text/plain, inline)]
s/allowScrollOps/allowScrollLock/

-- 
Thomas E. Dickey <dickey@invisible-island.net>
http://invisible-island.net
ftp://invisible-island.net
[signature.asc (application/pgp-signature, inline)]

Message sent on to antoine beaupre <anarcat@anarcat.ath.cx>:
Bug#580946. (Fri, 14 May 2010 00:12:07 GMT) Full text and rfc822 format available.

Added tag(s) moreinfo. Request was from Thomas Dickey <dickey@his.com> to control@bugs.debian.org. (Mon, 17 May 2010 09:33:09 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#580946; Package xterm. (Tue, 18 May 2010 00:09:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to The Anarcat <anarcat@anarcat.ath.cx>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Tue, 18 May 2010 00:09:05 GMT) Full text and rfc822 format available.

Message #75 received at 580946@bugs.debian.org (full text, mbox):

From: The Anarcat <anarcat@anarcat.ath.cx>
To: dickey@his.com, 580946-quiet@bugs.debian.org
Cc: 580946@bugs.debian.org, 580946-submitter@bugs.debian.org
Subject: Re: Bug#580946: #580946 interoperability problem with scroll lock toggles on xkb
Date: Mon, 17 May 2010 20:05:52 -0400
[Message part 1 (text/plain, inline)]
On Thu, May 13, 2010 at 07:44:57PM -0400, Thomas Dickey wrote:
> (by the way, patch #258 simply plugs a hole which seems that it should
> have appeared in #256 or before, the changes in this bug report come from #257)

(Yes, I have marked 256 as not affected because it's the version I know
as working, 257 may also be affected by the bug, I haven't tested it.)

> This report sounds like two bugs:
> 
> a) patch #257 introduces a binding for Scroll_Lock.  While I did make the feature
>    configurable (a compile-time ifdef could remove it entirely, or a resource can
>    disable most of the feature), I overlooked the fact that other people would be
>    using this orphaned key as well.

I see.

>    For a quick workaround - if you set allowScrollOps resource to false, is the
>    intercept of the key still interfering with your use of it?

Yes, that doesn't fix the problem:

XTerm*allowScrollOps: false
UXTerm*allowScrollOps: false

>    (if it is still interfering, I'll have to make the feature configurability
>    different, e.g., by deciding whether to add it to the translations dynamically).

(I'm not sure what the "translations" are, but I feel this should be
fixed in the next release, regardless of the way of doing it. removing
it entirely until a better fix is found would be the option I would
suggest, but then I am in a rather biased position. :P I would say
however that I'll switch away from xterm if this issue isn't fixed. As
things stand, I run the older version because the situation is rather
intolerable. :)

I noticed something else with the bug. Hitting scroll lock doesn't
"unfreeze" the terminal (it doesn't remove the lock). But focusing out
of the window, hitting scroll lock, and focusing back again *does* fix
the issue. So it's as if the scroll lock status was read only when
focusing in our out of the window. This seems like the wrong way to do
things in my opinion: xterm should just catch "keydown" events on that
key.

Arguably, if Xorg is handling scroll lock through XKB, it shouldn't let
that keypress propagate further either...

> b) the scroll-lock feature doesn't work with fast-scrolling.
> 
>    Fixing this may take more time than (a), so I'm inclined to focus on being able
>    to enable/disable the feature with low impact.

I would like this issue to be processed in a seperate bug report, as it
is unrelated to this one, AFAIK.

A.

-- 
La nature n'a créé ni maîtres ni esclaves
Je ne veux ni donner ni recevoir de lois.
                        - Denis Diderot
[signature.asc (application/pgp-signature, inline)]

Information stored :
Bug#580946; Package xterm. (Tue, 18 May 2010 00:15:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to The Anarcat <anarcat@anarcat.ath.cx>:
Extra info received and filed, but not forwarded. (Tue, 18 May 2010 00:15:05 GMT) Full text and rfc822 format available.

Message sent on to antoine beaupre <anarcat@anarcat.ath.cx>:
Bug#580946. (Tue, 18 May 2010 00:15:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#580946; Package xterm. (Tue, 18 May 2010 00:42:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@his.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Tue, 18 May 2010 00:42:03 GMT) Full text and rfc822 format available.

Message #88 received at 580946@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: The Anarcat <anarcat@anarcat.ath.cx>
Cc: 580946@bugs.debian.org, 580946-submitter@bugs.debian.org
Subject: Re: Bug#580946: #580946 interoperability problem with scroll lock toggles on xkb
Date: Mon, 17 May 2010 20:30:53 -0400 (EDT)
[Message part 1 (text/plain, inline)]
On Mon, 17 May 2010, The Anarcat wrote:

> On Thu, May 13, 2010 at 07:44:57PM -0400, Thomas Dickey wrote:
>> (by the way, patch #258 simply plugs a hole which seems that it should
>> have appeared in #256 or before, the changes in this bug report come from #257)
>
> (Yes, I have marked 256 as not affected because it's the version I know
> as working, 257 may also be affected by the bug, I haven't tested it.)
>
>> This report sounds like two bugs:
>>
>> a) patch #257 introduces a binding for Scroll_Lock.  While I did make the feature
>>    configurable (a compile-time ifdef could remove it entirely, or a resource can
>>    disable most of the feature), I overlooked the fact that other people would be
>>    using this orphaned key as well.
>
> I see.

yes... if I'd considered that aspect, I'd have defaults the resource to 
false.

>>    For a quick workaround - if you set allowScrollOps resource to false, is the
>>    intercept of the key still interfering with your use of it?
>
> Yes, that doesn't fix the problem:
>
> XTerm*allowScrollOps: false
> UXTerm*allowScrollOps: false

sorry for the confusion - I did correct my typo in a followup.

The resource is allowScrollLock:

       allowScrollLock (class AllowScrollLock)
               Specifies  whether  control sequences that set/query the Scroll
               Lock key should be allowed, as well as whether the Scroll  Lock
               key responds to user's keypress.  The default is "true."

>>    (if it is still interfering, I'll have to make the feature configurability
>>    different, e.g., by deciding whether to add it to the translations dynamically).
>
> (I'm not sure what the "translations" are, but I feel this should be
> fixed in the next release, regardless of the way of doing it. removing
> it entirely until a better fix is found would be the option I would
> suggest, but then I am in a rather biased position. :P I would say
> however that I'll switch away from xterm if this issue isn't fixed. As
> things stand, I run the older version because the situation is rather
> intolerable. :)

> I noticed something else with the bug. Hitting scroll lock doesn't
> "unfreeze" the terminal (it doesn't remove the lock). But focusing out
> of the window, hitting scroll lock, and focusing back again *does* fix
> the issue. So it's as if the scroll lock status was read only when
> focusing in our out of the window. This seems like the wrong way to do
> things in my opinion: xterm should just catch "keydown" events on that
> key.

I agree that if it did that, then you probably would not see the problem 
at all, since your keyboard configuration is apparently not passing the 
keypresses.

The focus aspect came about because if there is more than one terminal on 
the screen, it's unclear (otherwise) to which terminal the scroll lock 
applies.  (In development I considered instead clearing the scroll lock 
when exiting a window, but found this to work inconsistently).  But 
sensing the LED light on entry to the window seems to work well enough.

On the other hand, the focus aspect is supposed to go away when the 
resource is false.

xterm would still be passed an event (which it discards) when the resource 
is false.  I'm uncertain whether this event would interfere with your use
of the ScrollLock key - which is why I asked about the workaround.

> Arguably, if Xorg is handling scroll lock through XKB, it shouldn't let
> that keypress propagate further either...
>
>> b) the scroll-lock feature doesn't work with fast-scrolling.
>>
>>    Fixing this may take more time than (a), so I'm inclined to focus on being able
>>    to enable/disable the feature with low impact.
>
> I would like this issue to be processed in a seperate bug report, as it
> is unrelated to this one, AFAIK.
>
> A.
>
> -- 
> La nature n'a créé ni maîtres ni esclaves
> Je ne veux ni donner ni recevoir de lois.
>                        - Denis Diderot
>

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net

Message sent on to antoine beaupre <anarcat@anarcat.ath.cx>:
Bug#580946. (Tue, 18 May 2010 00:42:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#580946; Package xterm. (Tue, 18 May 2010 01:00:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to The Anarcat <anarcat@anarcat.ath.cx>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Tue, 18 May 2010 01:00:03 GMT) Full text and rfc822 format available.

Message #96 received at 580946@bugs.debian.org (full text, mbox):

From: The Anarcat <anarcat@anarcat.ath.cx>
To: Thomas Dickey <dickey@his.com>
Cc: 580946@bugs.debian.org, 580946-submitter@bugs.debian.org
Subject: Re: Bug#580946: #580946 interoperability problem with scroll lock toggles on xkb
Date: Mon, 17 May 2010 20:57:07 -0400
[Message part 1 (text/plain, inline)]
On Mon, May 17, 2010 at 08:30:53PM -0400, Thomas Dickey wrote:
> On Mon, 17 May 2010, The Anarcat wrote:
>
>> On Thu, May 13, 2010 at 07:44:57PM -0400, Thomas Dickey wrote:
>>> (by the way, patch #258 simply plugs a hole which seems that it should
>>> have appeared in #256 or before, the changes in this bug report come from #257)
>>
>> (Yes, I have marked 256 as not affected because it's the version I know
>> as working, 257 may also be affected by the bug, I haven't tested it.)
>>
>>> This report sounds like two bugs:
>>>
>>> a) patch #257 introduces a binding for Scroll_Lock.  While I did make the feature
>>>    configurable (a compile-time ifdef could remove it entirely, or a resource can
>>>    disable most of the feature), I overlooked the fact that other people would be
>>>    using this orphaned key as well.
>>
>> I see.
>
> yes... if I'd considered that aspect, I'd have defaults the resource to  
> false.

That would be helpful.

>>>    For a quick workaround - if you set allowScrollOps resource to false, is the
>>>    intercept of the key still interfering with your use of it?
>>
>> Yes, that doesn't fix the problem:
>>
>> XTerm*allowScrollOps: false
>> UXTerm*allowScrollOps: false
>
> sorry for the confusion - I did correct my typo in a followup.
>
> The resource is allowScrollLock:

Sorry for the trouble, yes, that does fix the problem.

> I agree that if it did that, then you probably would not see the problem  
> at all, since your keyboard configuration is apparently not passing the  
> keypresses.
>
> The focus aspect came about because if there is more than one terminal on 
> the screen, it's unclear (otherwise) to which terminal the scroll lock  
> applies.  (In development I considered instead clearing the scroll lock  
> when exiting a window, but found this to work inconsistently).  But  
> sensing the LED light on entry to the window seems to work well enough.

For me, scroll-lock is a bad metaphor for this feature. scroll-lock is
a "system-wide" thing: it should apply to all terminals, or the whole
"terminal" (x11 itself), not to individual terminals. Or if it would, it
would need to flash on and off as you would focus in and out of windows,
which seems a bit silly...

I think that control-s does control flow much better and is "standard"
enough for this feature to be unnecessary.

Then again, if the resource defaults to false, I have absolutely no
objection to it being present.

And if it defaults to true, I guess I'll just need to add this to my
ever growing needs of "tweaks necessary so that xterm works for me".. ;)

Now up to:

XTerm*metaSendsEscape: true
XTerm*bellIsUrgent:  true
XTerm*visualBell: true
XTerm*trimSelection: true
XTerm*allowScrollLock: false

Thanks for the quite efficient support...

A.
[signature.asc (application/pgp-signature, inline)]

Message sent on to antoine beaupre <anarcat@anarcat.ath.cx>:
Bug#580946. (Tue, 18 May 2010 01:00:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#580946; Package xterm. (Tue, 18 May 2010 01:15:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@his.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Tue, 18 May 2010 01:15:03 GMT) Full text and rfc822 format available.

Message #104 received at 580946@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: The Anarcat <anarcat@anarcat.ath.cx>
Cc: 580946@bugs.debian.org, 580946-submitter@bugs.debian.org
Subject: Re: Bug#580946: #580946 interoperability problem with scroll lock toggles on xkb
Date: Mon, 17 May 2010 21:10:50 -0400 (EDT)
On Mon, 17 May 2010, The Anarcat wrote:

>> sorry for the confusion - I did correct my typo in a followup.
>>
>> The resource is allowScrollLock:
>
> Sorry for the trouble, yes, that does fix the problem.

good - I'd like to spend a little time investigating the secondary issue,
but didn't want to neglect this.

>> I agree that if it did that, then you probably would not see the problem
>> at all, since your keyboard configuration is apparently not passing the
>> keypresses.
>>
>> The focus aspect came about because if there is more than one terminal on
>> the screen, it's unclear (otherwise) to which terminal the scroll lock
>> applies.  (In development I considered instead clearing the scroll lock
>> when exiting a window, but found this to work inconsistently).  But
>> sensing the LED light on entry to the window seems to work well enough.
>
> For me, scroll-lock is a bad metaphor for this feature. scroll-lock is
> a "system-wide" thing: it should apply to all terminals, or the whole
> "terminal" (x11 itself), not to individual terminals. Or if it would, it
> would need to flash on and off as you would focus in and out of windows,
> which seems a bit silly...

The latter was interesting - but not reliable enough to use.

> I think that control-s does control flow much better and is "standard"
> enough for this feature to be unnecessary.

Actually, control/s doesn't do what several users have requested: the 
ability to let xterm continue adding to the scrollback region while 
locking the display on a given slice.

control/s also isn't line-oriented.

By the way, this change from #257 improves control/s:

     * modify handling of scrollKey feature to ignore XON/XOFF keys.

(it fixes the very old issue that pressing control/s, control/q, etc. 
would force xterm down to the bottom of the scrolling window).

> Then again, if the resource defaults to false, I have absolutely no
> objection to it being present.

I'm making it default to false in the next patch (already edited).

>
> And if it defaults to true, I guess I'll just need to add this to my
> ever growing needs of "tweaks necessary so that xterm works for me".. ;)
>
> Now up to:
>
> XTerm*metaSendsEscape: true
> XTerm*bellIsUrgent:  true
> XTerm*visualBell: true
> XTerm*trimSelection: true
> XTerm*allowScrollLock: false
>
> Thanks for the quite efficient support...

no problem (report bugs)

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net




Message sent on to antoine beaupre <anarcat@anarcat.ath.cx>:
Bug#580946. (Tue, 18 May 2010 01:15:04 GMT) Full text and rfc822 format available.

Reply sent to Julien Cristau <jcristau@debian.org>:
You have taken responsibility. (Sun, 06 Jun 2010 13:03:09 GMT) Full text and rfc822 format available.

Notification sent to antoine beaupre <anarcat@anarcat.ath.cx>:
Bug acknowledged by developer. (Sun, 06 Jun 2010 13:03:09 GMT) Full text and rfc822 format available.

Message #112 received at 580946-close@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: 580946-close@bugs.debian.org
Subject: Bug#580946: fixed in xterm 259-1
Date: Sun, 06 Jun 2010 13:02:26 +0000
Source: xterm
Source-Version: 259-1

We believe that the bug you reported is fixed in the latest version of
xterm, which is due to be installed in the Debian FTP archive:

xterm_259-1.diff.gz
  to main/x/xterm/xterm_259-1.diff.gz
xterm_259-1.dsc
  to main/x/xterm/xterm_259-1.dsc
xterm_259-1_i386.deb
  to main/x/xterm/xterm_259-1_i386.deb
xterm_259.orig.tar.gz
  to main/x/xterm/xterm_259.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 580946@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Julien Cristau <jcristau@debian.org> (supplier of updated xterm package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Sun, 06 Jun 2010 14:39:27 +0200
Source: xterm
Binary: xterm
Architecture: source i386
Version: 259-1
Distribution: unstable
Urgency: low
Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Changed-By: Julien Cristau <jcristau@debian.org>
Description: 
 xterm      - X terminal emulator
Closes: 580946 581647 581653
Changes: 
 xterm (259-1) unstable; urgency=low
 .
   * README.Debian: drop obsolete content, including a link to the old Debian X
     FAQ (closes: #581647).  Thanks, Bob Proulx!
   * Add a NEWS entry about the changed default value for pointerMode (closes:
     #581653).  Request and wording from Bob Proulx, thanks!
   * Refresh 902_windowops.diff and 904_fontops.diff.
   * New upstream release
     + change default for allowScrollLock resource to false, noting that the
       supposedly unused key has been useful for various rebindings
       (closes: #580946)
   * Update copy of XTerm FAQ to revision 1.138 (dated 2010/05/15).
   * Bump copyright year in debian/copyright.
Checksums-Sha1: 
 b234f75682e41d1681d08d1d22480876829de03a 1948 xterm_259-1.dsc
 b4cf20ad67faa221d308b92c4daf8df4f9f122fb 923729 xterm_259.orig.tar.gz
 77582361df85f48a4dce809abd0e49af799035a9 79160 xterm_259-1.diff.gz
 b382cf993491f64020014c29b1bb2455b441b955 528252 xterm_259-1_i386.deb
Checksums-Sha256: 
 af589f85970d54ecf04ecbd72cda7e2500ae35189e1f672b60e8a1b38bf884a4 1948 xterm_259-1.dsc
 148393286c044eec41385500041245dbe38dc86909a2eb8ec65ed0a5a8234fd5 923729 xterm_259.orig.tar.gz
 66278e2ca8ea4f6b10e1d54e391922dd3b88bc3e5bbb54aabe039699694d6c03 79160 xterm_259-1.diff.gz
 c87bc571a2ed30addff39a2a4125fdad90a044a68796802ea4318060dd40ff15 528252 xterm_259-1_i386.deb
Files: 
 01da83afad63111f28ed6a68a24c97c3 1948 x11 optional xterm_259-1.dsc
 22037e1b794d749072310cb142800f05 923729 x11 optional xterm_259.orig.tar.gz
 f08b291c3dec0a6d57ecfa4f971b3205 79160 x11 optional xterm_259-1.diff.gz
 4223b75c387d2bf2fd5ff6fa447366fe 528252 x11 optional xterm_259-1_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iQIcBAEBCAAGBQJMC5irAAoJEDEBgAUJBeQM+JMP/jP/vQwx3M7Xw1b/mv3R4Xdv
/Bolrkx/yLgCPJnDsIEv4nqIyBOMmhV+nn06mt6FS2yRYCWyfmGDFuCtD9i6O0UE
N+lQonFZg+Q92wz7J1PqvZyjwO1/H8jQOtxyZ7sTZ5unbCkMtRUDuEblTL7is9tQ
3Jv606QyYJ4YKjH2Z3dA0juk4V/eQOCDpWJiYfWAsfMYkjN9G+1mu9+sBoMmE1aL
JopLM7A1wgoMlxks1bvO7dIQ1rYkt+b4nArvbx757e9lViv5wT6nk14haueDqqiO
EcZAyfw76l9PVoEMBNC8ZYw1wW367CO8c4a0eU/E+84r62Nm3Rkmi8mwiQpIluKL
cAUZWOMV7D7K2HrgzwxOffJ1JJHp92zPaC4UbLaB1ZjfvNgKnyq0K1SxPVy9ZwdH
CgDfPkgYm07PhfYQr3kzv2O6f8ryY+OeExc1bsEaTljsWPru0b+YYe6EXednXwgK
T/ExmmyW4hcV4afNO274IkZtATRgMlKB/2L7qNk5/I5LU7vhNch6VWdEtJ2pF9qK
iQ502mG30zy37EWe+jqE/Buav58iMDO9eAYCxhBY15cGnScjcKqrxdd6Peicu12v
RvM8nLomYK+tt0EJ1EVfBHz+DECix9Gi/bIOislm/9yBpIqO35E1qmFl12RnBeP/
r/8a+39vAZYZ5/o1aD9x
=P2bR
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 15 Jul 2010 07:33:54 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 10:38:41 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.